.486                      ; create 32 bit code
.model flat, stdcall      ; 32 bit memory model
option casemap :none      ; case sensitive

include \masm32\include\windows.inc
include \masm32\include\masm32.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\macros\macros.asm
;    Unicode-,    ,     .       Unicode,       
include \masm32\macros\ucmacros.asm

includelib \masm32\lib\masm32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib

GPPHDR_VER=10h ;  -    0x10,   

WM_WA_IPC equ WM_USER ;     
IPC_ISPLAYING equ 104 ; ,      - 
IPC_PLAYING_FILE equ 3003 ;,     

IPC_GETLISTPOS equ 125 ;     
IPC_GETPLAYLISTFILEW equ 214 ;     Unicode
IPC_GET_EXTENDED_FILE_INFOW equ 3026 ;      Unicode

CheckPlaying PROTO :DWORD,:DWORD,:DWORD,:DWORD ;     

winampGeneralPurposePlugin STRUCT ;,      
  version dd ?             ; version of the plugin, defined in "gen_empty.h"
  description dd ?         ; name/title of the plugin, defined in "gen_empty.h"
  init dd ?                ; function which will be executed on init event
  config dd ?              ; function which will be executed on config event
  quit dd ?                ; function which will be executed on quit event
  hwndParent dd ?          ; (?)
  hDllInstance dd ?        ; (?)
winampGeneralPurposePlugin ENDS

extendedFileInfoStruct STRUCT ;      
  filename dd ? ;     
  metadata dd ? ;  ,    , , Artist, Title, Genre  ..
  retvalue dd ? ;  ,    
  retlen dd ? ; 
extendedFileInfoStruct ENDS


.data ;  -  
  plugin_name db "Test Plugin",0 ;  -       
  ;     -  0x10,   ,
  ;      (     ),
  ;  ,     ,
  ;  ,    .
  ;   ,    - hWnd    dllInstance.

  plugin winampGeneralPurposePlugin {GPPHDR_VER,offset plugin_name,offset init,offset config,offset quit,0,0}

  WSTR ArtistW,"Artist"

.data?
  old_proc dd ? ;     
  is_unicode dd ? ;   

  fileinfo extendedFileInfoStruct <> ;


.code

LibMain proc instance:DWORD,reason:DWORD,reserved:DWORD ;,    dll
  .if reason == DLL_PROCESS_ATTACH
    mov eax,1 ; 1   dll
  .endif
ret
LibMain ENDP

;     -               
winampGetGeneralPurposePlugin PROC
  mov eax,offset plugin ;  
ret
winampGetGeneralPurposePlugin ENDP

config PROC ;    
  invoke MessageBox,0,chr$("   ."),offset plugin_name,0
  xor eax,eax
ret
config ENDP

init PROC ;   
  invoke MessageBox,0,chr$(" ."),offset plugin_name,0

  mov old_proc,FUNC(GetWindowLong,plugin.hwndParent,GWL_WNDPROC) ;     
  mov is_unicode,FUNC(IsWindowUnicode,plugin.hwndParent) ;   ?

  .if is_unicode==1 ; 
    invoke SetWindowLongW,plugin.hwndParent,GWL_WNDPROC,offset CheckPlaying ;     (Unicode-)
  .else
    invoke SetWindowLong,plugin.hwndParent,GWL_WNDPROC,offset CheckPlaying ;    
  .endif

  xor eax,eax
ret
init ENDP

quit PROC ;   
  .if is_unicode==1 ;   
    invoke SetWindowLongW,plugin.hwndParent,GWL_WNDPROC,old_proc ;       (Unicode-)
  .else
    invoke SetWindowLong,plugin.hwndParent,GWL_WNDPROC,old_proc ;      
  .endif

  invoke MessageBox,0,chr$(" ."),offset plugin_name,0
  xor eax,eax
ret
quit ENDP

CheckPlaying PROC hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
  LOCAL temp_info [2048] :BYTE ;      

  .if uMsg==WM_WA_IPC && lParam==IPC_PLAYING_FILE ;       
    invoke SendMessage,plugin.hwndParent,WM_WA_IPC,0,IPC_ISPLAYING ;,   
    cmp eax,1 ; , 
    jne no_action ;  

    mov word ptr temp_info[0],0 ;       ,      ,      null-

    invoke SendMessage,plugin.hwndParent,WM_WA_IPC,0,IPC_GETLISTPOS ;    
    invoke SendMessage,plugin.hwndParent,WM_WA_IPC,eax,IPC_GETPLAYLISTFILEW ;     Unicode

    mov fileinfo.filename,eax ;        
    mov fileinfo.metadata,offset ArtistW ;   
    lea eax,temp_info ;     .
    mov fileinfo.retvalue,eax
    mov fileinfo.retlen,1022 ; -  , .. Unicode

    invoke SendMessage,plugin.hwndParent,WM_WA_IPC,offset fileinfo,IPC_GET_EXTENDED_FILE_INFOW ; 

    invoke MessageBoxW,plugin.hwndParent,addr temp_info,offset ArtistW,0 ;  
  .endif

no_action:

  .if is_unicode==1 ;   
    invoke CallWindowProcW,old_proc,plugin.hwndParent, uMsg, wParam, lParam ;       (Unicode-)
  .else
    invoke CallWindowProc,old_proc,plugin.hwndParent, uMsg, wParam, lParam ;      
  .endif
ret
CheckPlaying ENDP

end LibMain ; ,     dll - LibMain